<script setup lang="ts">
import StockTable from './StockTable.vue'
import HistoryImportDialog from './HistoryImportDialog.vue'
import StockUpdate from './StockUpdate.vue'
import StockCheckDialog from './StockCheckDialog.vue'
import StockDialogImport from './StockImportDialog.vue'
import ReceiptImportDialog from './ReceiptImportDialog.vue'
import ReceiptImportDialogDetails from './ReceiptImportDialogDetails.vue'
import { computed, onMounted } from 'vue'
import MaterialView from './materialView.vue'
import { useMaterialStore } from '@/stores/material'
import type { Material } from '@/types/Material'
import MaterialTable from './MaterialTable.vue'

const materialStore = useMaterialStore()
const stock: Material[] = materialStore.material

function showDialog() {
  materialStore.showImportDialog()
}
function printCheckStock() {
  materialStore.showCheckStock()
}

function showHistory() {
  materialStore.historyDialog = true
}

function showUpdate() {
  materialStore.updateDialog = true
}

const countAlmost = computed(function () {
  const A = materialStore.countAlmostStock()
  return A
})
const countOut = computed(function () {
  const m = materialStore.countOutOfStock()
  return m
})

onMounted(async () => {
  await materialStore.getMaterials()
  materialStore.tableStock = materialStore.material
  
})
</script>
<template>
  <div id="stockView" class="d-flex justify-center">
    <v-card variant="tonal" width="100%" min-width="500" max-width="1200" max-height="600" min-height="900"
      class="ma-3 bg-teal-darken-4" :elevation="18">
      <div style="
          background-color: rgb(0, 0, 0);
          color: aliceblue;
          text-align: center;
          font-size: 50px;
          font-family: Arial, Helvetica, sans-serif;
        ">
        STOCK
      </div>
      <v-row>
        <v-col>
          <v-card class="ma-2 pa-2 d-flex justify-end mb-6 " max-width="344" min-height="117">
            <v-card class="mx-auto" max-width="330" min-width="330" title="ALL Stock : " prepend-icon="" variant="flat"
              @click="materialStore.All = true, materialStore.changeTable(), console.log(materialStore.All)">
              <v-card-text style="text-align: right; font-size: xxx-large; margin: 2%;"></v-card-text>
            </v-card>
          </v-card>
        </v-col>

        <v-col>
          <v-card class="ma-2 pa-2 d-flex justify-end mb-6" max-width="344" min-height="117" style="background-color: rgb(250, 197, 24);">
            <v-card class="mx-auto" max-width="330" min-width="330" title="Almost out of stock  : " variant="flat"
              style="background-color: rgb(250, 197, 24);" @click="materialStore.Almost = true, materialStore.changeTable()">
              <v-card-text style="text-align: right; font-size: xxx-large; margin: 2%;">
                {{ countAlmost }}
              </v-card-text>
            </v-card>
          </v-card>
        </v-col>

        <v-col>
          <v-card class="ma-2 pa-2 d-flex justify-end mb-6 " max-width="344" min-height="117" style="background-color: rgb(255, 0, 0);">
            <v-card class="mx-auto" max-width="330" min-width="330" title="Out of Stock : " prepend-icon="" variant="flat"
              style="background-color: rgb(241, 74, 7);" @click="materialStore.Out = true, materialStore.changeTable()">
              <v-card-text style="text-align: right; font-size: xxx-large; margin: 2%;">
                {{ countOut }}
              </v-card-text>
            </v-card>
          </v-card>
        </v-col>
      </v-row>

      <v-card variant="tonal" class="ma-2 bg-teal-darken-4">
        <v-container>
          <v-card min-width="500" height="auto" elevation="6">
            <MaterialTable :stocks="stock" />
          </v-card>
          <v-sheet>
            <v-container class="bg-teal-darken-4">
              <v-row>
                <v-col cols="12" md="6">
                  <v-btn @click="showHistory()">History</v-btn>
                </v-col>
                <v-col cols="12" md="6" style="text-align: right">
                  <v-btn @click="printCheckStock()" style="margin-right: 10px">Check</v-btn>
                  <!--<v-btn @click="showUpdate()" style="margin-right: 10px" color="green">Update Stock</v-btn>-->
                  <v-btn @click="showDialog()" style="margin-right: -15px">Buy Stock</v-btn>
                </v-col>
              </v-row>
            </v-container>
          </v-sheet>
        </v-container>
      </v-card>
    </v-card>
  </div>
  <StockDialogImport />
  <StockUpdate />
  <HistoryImportDialog />
  <ReceiptImportDialog />
  <StockCheckDialog :stocks="stock" />
  <ReceiptImportDialogDetails />
  <StockTable></StockTable>
  <MaterialView></MaterialView>
  
</template>
<style scoped>
#stockView {
  background-color: #212121;
  height: 100%;
}
</style>
